diff a/src/hotspot/share/ci/ciObjArrayKlass.hpp b/src/hotspot/share/ci/ciObjArrayKlass.hpp
--- a/src/hotspot/share/ci/ciObjArrayKlass.hpp
+++ b/src/hotspot/share/ci/ciObjArrayKlass.hpp
@@ -74,8 +74,14 @@
 
   static ciObjArrayKlass* make(ciKlass* element_klass);
   static ciObjArrayKlass* make(ciKlass* element_klass, int dims);
 
   virtual ciKlass* exact_klass();
+
+  virtual bool can_be_inline_array_klass() {
+    return element_klass()->can_be_inline_klass();
+  }
+
+  virtual bool is_elem_null_free() const;
 };
 
 #endif // SHARE_CI_CIOBJARRAYKLASS_HPP
